diff --git a/kernel/receive.c b/kernel/receive.c
index a176653c88616b1bc871fe52fcea778b5e189f69..a4e5c83d5cb77f520bba42113f1cd6eaca2c3d2d 100644
--- a/kernel/receive.c
+++ b/kernel/receive.c
@@ -537,50 +811,86 @@ err_keypair:
 	rcu_read_unlock_bh();
 	wg_peer_put(peer);
 	dev_kfree_skb(skb);
+	wg_dbg("Exiting wg_packet_consume_data\n");
 }
 
 void wg_packet_receive(struct wg_device *wg, struct sk_buff *skb)
 {
-	if (unlikely(prepare_skb_header(skb, wg) < 0))
+	wg_dbg("Entering wg_packet_receive: wg=%px, skb=%px\n", wg, skb);
+
+	if (unlikely(prepare_skb_header(skb, wg) < 0)) {
+		wg_dbg("prepare_skb_header failed\n");
 		goto err;
-	switch (SKB_TYPE_LE32(skb)) {
+	}
+
+	/* Determine packet type */
+	uint32_t skb_type = SKB_TYPE_LE32(skb);
+	wg_dbg("Packet type: %u\n", skb_type);
+
+	switch (skb_type) {
 	case cpu_to_le32(MESSAGE_HANDSHAKE_INITIATION):
 	case cpu_to_le32(MESSAGE_HANDSHAKE_RESPONSE):
 	case cpu_to_le32(MESSAGE_HANDSHAKE_COOKIE): {
 		int cpu, ret = -EBUSY;
+		wg_dbg("Received handshake packet\n");
 
-		if (unlikely(!rng_is_initialized()))
+		if (unlikely(!rng_is_initialized())) {
+			wg_dbg("RNG is not initialized, dropping packet\n");
 			goto drop;
-		if (atomic_read(&wg->handshake_queue_len) > MAX_QUEUED_INCOMING_HANDSHAKES / 2) {
+		}
+
+		int queue_len = atomic_read(&wg->handshake_queue_len);
+		wg_dbg("Current handshake queue length: %d\n", queue_len);
+
+		if (queue_len > MAX_QUEUED_INCOMING_HANDSHAKES / 2) {
+			wg_dbg("Queue length exceeds threshold, trying spinlock\n");
 			if (spin_trylock_bh(&wg->handshake_queue.ring.producer_lock)) {
 				ret = __ptr_ring_produce(&wg->handshake_queue.ring, skb);
+				wg_dbg("__ptr_ring_produce returned: %d\n", ret);
 				spin_unlock_bh(&wg->handshake_queue.ring.producer_lock);
+			} else {
+				wg_dbg("Failed to acquire spinlock\n");
 			}
-		} else
+		} else {
 			ret = ptr_ring_produce_bh(&wg->handshake_queue.ring, skb);
+			wg_dbg("ptr_ring_produce_bh returned: %d\n", ret);
+		}
+
 		if (ret) {
-	drop:
+			wg_dbg("Failed to queue handshake packet, dropping\n");
+		drop:
 			net_dbg_skb_ratelimited("%s: Dropping handshake packet from %pISpfsc\n",
 						wg->dev->name, skb);
 			goto err;
 		}
+
 		atomic_inc(&wg->handshake_queue_len);
+		wg_dbg("Handshake queue length incremented\n");
+
 		cpu = wg_cpumask_next_online(&wg->handshake_queue.last_cpu);
+		wg_dbg("Selected CPU for work queue: %d\n", cpu);
+
 		/* Queues up a call to packet_process_queued_handshake_packets(skb): */
 		queue_work_on(cpu, wg->handshake_receive_wq,
 			      &per_cpu_ptr(wg->handshake_queue.worker, cpu)->work);
 		break;
 	}
 	case cpu_to_le32(MESSAGE_DATA):
+		wg_dbg("Received data packet\n");
 		PACKET_CB(skb)->ds = ip_tunnel_get_dsfield(ip_hdr(skb), skb);
+		wg_dbg("DS field set to: %u\n", PACKET_CB(skb)->ds);
 		wg_packet_consume_data(wg, skb);
 		break;
 	default:
 		WARN(1, "Non-exhaustive parsing of packet header lead to unknown packet type!\n");
+		wg_dbg("Unknown packet type: %u, dropping\n", skb_type);
 		goto err;
 	}
+
+	wg_dbg("Exiting wg_packet_receive normally\n");
 	return;
 
 err:
 	dev_kfree_skb(skb);
+	wg_dbg("Exiting wg_packet_receive with error\n");
 }
diff --git a/kernel/selftest/allowedips.c b/kernel/selftest/allowedips.c
index 3d1f64ff2e1225aea957f24c08b05e859956dc6f..6e341fc36dac33e6d5b5d7e884efb1133feaada2 100644
--- a/kernel/selftest/allowedips.c
+++ b/kernel/selftest/allowedips.c
@@ -461,6 +461,10 @@ static __init struct wg_peer *init_peer(void)
 	wg_allowedips_insert_v##version(&t, ip##version(ipa, ipb, ipc, ipd), \
 					cidr, mem, &mutex)
 
+#define remove(version, mem, ipa, ipb, ipc, ipd, cidr)                       \
+	wg_allowedips_remove_v##version(&t, ip##version(ipa, ipb, ipc, ipd), \
+					cidr, mem, &mutex)
+
 #define maybe_fail() do {                                               \
 		++i;                                                    \
 		if (!_s) {                                              \
@@ -586,6 +590,38 @@ bool __init wg_allowedips_selftest(void)
 	test_negative(4, a, 192, 0, 0, 0);
 	test_negative(4, a, 255, 0, 0, 0);
 
+	insert(4, a, 1, 0, 0, 0, 32);
+	insert(4, a, 192, 0, 0, 0, 24);
+	insert(6, a, 0x24446801, 0x40e40800, 0xdeaebeef, 0xdefbeef, 128);
+	insert(6, a, 0x24446800, 0xf0e40800, 0xeeaebeef, 0, 98);
+	test(4, a, 1, 0, 0, 0);
+	test(4, a, 192, 0, 0, 1);
+	test(6, a, 0x24446801, 0x40e40800, 0xdeaebeef, 0xdefbeef);
+	test(6, a, 0x24446800, 0xf0e40800, 0xeeaebeef, 0x10101010);
+	remove(4, a, 192, 0, 0, 0, 32);
+	test(4, a, 192, 0, 0, 1);
+	test_boolean(!remove(4, NULL, 192, 0, 0, 0, 24));
+	test_boolean(!remove(4, b, 192, 0, 0, 0, 24));
+	test_boolean(remove(4, b, 192, 0, 0, 0, 33) == -EINVAL);
+	remove(4, a, 192, 0, 0, 0, 24);
+	test_negative(4, a, 192, 0, 0, 1);
+	remove(4, a, 1, 0, 0, 0, 32);
+	test_negative(4, a, 1, 0, 0, 0);
+	remove(6, a, 0x24446801, 0x40e40800, 0xdeaebeef, 0xdefbeef, 96);
+	test(6, a, 0x24446801, 0x40e40800, 0xdeaebeef, 0xdefbeef);
+	test_boolean(!remove(6, NULL, 0x24446801, 0x40e40800,
+			     0xdeaebeef, 0xdefbeef, 128));
+	test_boolean(!remove(6, b, 0x24446801, 0x40e40800,
+			     0xdeaebeef, 0xdefbeef, 128));
+	test_boolean(remove(6, a, 0x24446801, 0x40e40800,
+			    0xdeaebeef, 0xdefbeef, 129) == -EINVAL);
+	remove(6, a, 0x24446801, 0x40e40800, 0xdeaebeef, 0xdefbeef, 128);
+	test_negative(6, a, 0x24446801, 0x40e40800, 0xdeaebeef, 0xdefbeef);
+	remove(6, b, 0x24446800, 0xf0e40800, 0xeeaebeef, 0, 98);
+	test(6, a, 0x24446800, 0xf0e40800, 0xeeaebeef, 0x10101010);
+	remove(6, a, 0x24446800, 0xf0e40800, 0xeeaebeef, 0, 98);
+	test_negative(6, a, 0x24446800, 0xf0e40800, 0xeeaebeef, 0x10101010);
+
 	wg_allowedips_free(&t, &mutex);
 	wg_allowedips_init(&t);
 	insert(4, a, 192, 168, 0, 0, 16);
diff --git a/kernel/selftest/cookie.c b/kernel/selftest/cookie.c
new file mode 100644
index 0000000000000000000000000000000000000000..8e792334c0c04c3cb7351fe2d518089ba2e57a0d
--- /dev/null
+++ b/kernel/selftest/cookie.c
@@ -0,0 +1,32 @@
+// SPDX-License-Identifier: GPL-2.0
+
+#ifdef DEBUG
+bool __init wg_cookie_policy_selftest(void)
+{
+	static const struct {
+		bool under_load;
+		enum cookie_mac_state state;
+		enum cookie_validation_action expected;
+	} cases[] = {
+		{ false, INVALID_MAC, WG_COOKIE_DROP },
+		{ false, VALID_MAC_BUT_NO_COOKIE, WG_COOKIE_ACCEPT },
+		{ false, VALID_MAC_WITH_COOKIE_BUT_RATELIMITED, WG_COOKIE_DROP },
+		{ false, VALID_MAC_WITH_COOKIE, WG_COOKIE_DROP },
+		{ true, INVALID_MAC, WG_COOKIE_DROP },
+		{ true, VALID_MAC_BUT_NO_COOKIE, WG_COOKIE_CHALLENGE },
+		{ true, VALID_MAC_WITH_COOKIE_BUT_RATELIMITED, WG_COOKIE_DROP },
+		{ true, VALID_MAC_WITH_COOKIE, WG_COOKIE_ACCEPT }
+	};
+	size_t i;
+
+	for (i = 0; i < ARRAY_SIZE(cases); ++i) {
+		if (wg_cookie_validation_action(cases[i].under_load,
+						cases[i].state) != cases[i].expected) {
+			pr_err("cookie policy self-test %zu: FAIL\n", i + 1);
+			return false;
+		}
+	}
+	pr_info("cookie policy self-tests: pass\n");
+	return true;
+}
+#endif
diff --git a/kernel/send.c b/kernel/send.c
index 0d48e0f4a1ba3e1f11825136a65de0867b204496..5b0cdf72548620f76d43b6c5b6bae8e362a1555c 100644
--- a/kernel/send.c
+++ b/kernel/send.c
@@ -1,6 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
 #include "queueing.h"
@@ -8,53 +9,105 @@
 #include "device.h"
 #include "peer.h"
 #include "socket.h"
+#include "wg_tcp.h"
 #include "messages.h"
 #include "cookie.h"
+#include "wg_tcp_debug.h"
 
 #include <linux/uio.h>
 #include <linux/inetdevice.h>
 #include <linux/socket.h>
+#include <linux/wireguard.h>
 #include <net/ip_tunnels.h>
 #include <net/udp.h>
 #include <net/sock.h>
 
+#include <linux/skbuff.h>
+#include <linux/ip.h>
+#include <linux/tcp.h>
+#include <linux/printk.h>
+#include <linux/in.h>
+#include <linux/netdevice.h>
+#include <linux/inet.h>
+
+#include <linux/types.h>
+#include <linux/byteorder/generic.h>
+#include <linux/etherdevice.h>
+#include <net/inet_ecn.h>
+#include <net/route.h>
+#include <linux/netdevice.h>
+
 static void wg_packet_send_handshake_initiation(struct wg_peer *peer)
 {
 	struct message_handshake_initiation packet;
 
-	if (!wg_birthdate_has_expired(atomic64_read(&peer->last_sent_handshake),
-				      REKEY_TIMEOUT))
-		return; /* This function is rate limited. */
+	/* Enter function with peer information */
+	wg_dbg("Entering wg_packet_send_handshake_initiation with peer=%px\n", peer);
+
+	/* Check rate limiting */
+	if (!wg_birthdate_has_expired(atomic64_read(&peer->last_sent_handshake), REKEY_TIMEOUT)) {
+		wg_dbg("wg_packet_send_handshake_initiation: Handshake rate limit not expired for peer=%px\n", peer);
+		wg_dbg("Exiting wg_packet_send_handshake_initiation\n");
+		return;
+	}
 
+	/* Update last sent handshake time */
 	atomic64_set(&peer->last_sent_handshake, ktime_get_coarse_boottime_ns());
-	net_dbg_ratelimited("%s: Sending handshake initiation to peer %llu (%pISpfsc)\n",
-			    peer->device->dev->name, peer->internal_id,
-			    &peer->endpoint.addr);
 
+	/* Log handshake initiation attempt */
+	wg_dbg("%s: Sending handshake initiation to peer %llu (%pISpfsc)\n",
+	       peer->device->dev->name, peer->internal_id,
+	       &peer->endpoint.addr);
+
+	/* Create handshake initiation */
 	if (wg_noise_handshake_create_initiation(&packet, &peer->handshake)) {
+		wg_dbg("wg_packet_send_handshake_initiation: Handshake initiation created successfully for peer=%px\n", peer);
+
+		/* Print out the contents of the handshake initiation packet */
+		wg_dbg("wg_packet_send_handshake_initiation: Handshake packet contents: %*ph\n",
+		       (int)sizeof(packet), &packet);
+
+		/* Add MAC to packet */
 		wg_cookie_add_mac_to_packet(&packet, sizeof(packet), peer);
+		wg_dbg("wg_packet_send_handshake_initiation: MAC added to handshake packet for peer=%px\n", peer);
+
+		/* Timers and sending operations */
 		wg_timers_any_authenticated_packet_traversal(peer);
 		wg_timers_any_authenticated_packet_sent(peer);
-		atomic64_set(&peer->last_sent_handshake,
-			     ktime_get_coarse_boottime_ns());
-		wg_socket_send_buffer_to_peer(peer, &packet, sizeof(packet),
-					      HANDSHAKE_DSCP);
+
+		/* Update last sent handshake time again */
+		atomic64_set(&peer->last_sent_handshake, ktime_get_coarse_boottime_ns());
+
+		/* Send the handshake packet */
+		wg_socket_send_buffer_to_peer(peer, &packet, sizeof(packet), HANDSHAKE_DSCP);
+		wg_dbg("wg_packet_send_handshake_initiation: Handshake packet sent to peer=%px\n", peer);
+
+		/* Mark handshake initiation complete */
 		wg_timers_handshake_initiated(peer);
+	} else {
+		/* Log failure to create handshake initiation */
+		wg_dbg("wg_packet_send_handshake_initiation: Failed to create handshake initiation for peer=%px\n", peer);
 	}
+
+	/* Exit function */
+	wg_dbg("Exiting wg_packet_send_handshake_initiation\n");
 }
 
 void wg_packet_handshake_send_worker(struct work_struct *work)
 {
+	wg_dbg("Entering wg_packet_handshake_send_worker with work=%px\n", work);
 	struct wg_peer *peer = container_of(work, struct wg_peer,
 					    transmit_handshake_work);
 
 	wg_packet_send_handshake_initiation(peer);
 	wg_peer_put(peer);
+	wg_dbg("Exiting wg_packet_handshake_send_worker\n");
 }
 
 void wg_packet_send_queued_handshake_initiation(struct wg_peer *peer,
 						bool is_retry)
 {
+	wg_dbg("Entering wg_packet_send_queued_handshake_initiation with peer=%px, is_retry=%d\n", peer, is_retry);
 	if (!is_retry)
 		peer->timer_handshake_attempts = 0;
 
@@ -80,10 +133,12 @@ void wg_packet_send_queued_handshake_initiation(struct wg_peer *peer,
 		wg_peer_put(peer);
 out:
 	rcu_read_unlock_bh();
+	wg_dbg("Exiting wg_packet_send_queued_handshake_initiation\n");
 }
 
 void wg_packet_send_handshake_response(struct wg_peer *peer)
 {
+	wg_dbg("Entering wg_packet_send_handshake_response with peer=%px\n", peer);
 	struct message_handshake_response packet;
 
 	atomic64_set(&peer->last_sent_handshake, ktime_get_coarse_boottime_ns());
@@ -93,6 +148,14 @@ void wg_packet_send_handshake_response(struct wg_peer *peer)
 
 	if (wg_noise_handshake_create_response(&packet, &peer->handshake)) {
 		wg_cookie_add_mac_to_packet(&packet, sizeof(packet), peer);
+
+		wg_dbg("MAC added to handshake response packet\n");
+		wg_dbg("Handshake Response Packet: %*ph\n",
+			(int)sizeof(packet), &packet);
+		wg_dbg("Peer Cookie Parameters: peer=%px, handshake=%px, index=%u\n",
+			peer, &peer->handshake, packet.sender_index);
+
+
 		if (wg_noise_handshake_begin_session(&peer->handshake,
 						     &peer->keypairs)) {
 			wg_timers_session_derived(peer);
@@ -105,24 +168,41 @@ void wg_packet_send_handshake_response(struct wg_peer *peer)
 						      HANDSHAKE_DSCP);
 		}
 	}
+	wg_dbg("Exiting wg_packet_send_handshake_response\n");
 }
 
 void wg_packet_send_handshake_cookie(struct wg_device *wg,
 				     struct sk_buff *initiating_skb,
 				     __le32 sender_index)
 {
+	wg_dbg("Entering wg_packet_send_handshake_cookie with wg=%px, initiating_skb=%px, sender_index=%u\n", wg, initiating_skb, sender_index);
 	struct message_handshake_cookie packet;
 
+	wg_dbg("Creating handshake cookie\n");
+	wg_dbg("initiating_skb len=%u\n", initiating_skb->len);
+	wg_dbg("Initiating SKB Data: %*ph\n",
+	(int)initiating_skb->len, initiating_skb->data);
+
+	wg_dbg("Cookie Checker: %px\n", &wg->cookie_checker);
+
+
 	net_dbg_skb_ratelimited("%s: Sending cookie response for denied handshake message for %pISpfsc\n",
 				wg->dev->name, initiating_skb);
 	wg_cookie_message_create(&packet, initiating_skb, sender_index,
 				 &wg->cookie_checker);
+
+	wg_dbg("Handshake Cookie Packet: %*ph\n",
+		(int)sizeof(packet), &packet);
+
 	wg_socket_send_buffer_as_reply_to_skb(wg, initiating_skb, &packet,
 					      sizeof(packet));
+
+	wg_dbg("Exiting wg_packet_send_handshake_cookie\n");
 }
 
 static void keep_key_fresh(struct wg_peer *peer)
 {
+	wg_dbg("Entering keep_key_fresh with peer=%px\n", peer);
 	struct noise_keypair *keypair;
 	bool send;
 
@@ -136,14 +216,18 @@ static void keep_key_fresh(struct wg_peer *peer)
 
 	if (unlikely(send))
 		wg_packet_send_queued_handshake_initiation(peer, false);
+	wg_dbg("Exiting keep_key_fresh\n");
 }
 
 static unsigned int calculate_skb_padding(struct sk_buff *skb)
 {
+	wg_dbg("Entering calculate_skb_padding with skb=%px\n", skb);
 	unsigned int padded_size, last_unit = skb->len;
 
-	if (unlikely(!PACKET_CB(skb)->mtu))
+	if (unlikely(!PACKET_CB(skb)->mtu)) {
+		wg_dbg("Exiting calculate_skb_padding\n");
 		return ALIGN(last_unit, MESSAGE_PADDING_MULTIPLE) - last_unit;
+	}
 
 	/* We do this modulo business with the MTU, just in case the networking
 	 * layer gives us a packet that's bigger than the MTU. In that case, we
@@ -156,77 +240,130 @@ static unsigned int calculate_skb_padding(struct sk_buff *skb)
 
 	padded_size = min(PACKET_CB(skb)->mtu,
 			  ALIGN(last_unit, MESSAGE_PADDING_MULTIPLE));
+	wg_dbg("Exiting calculate_skb_padding\n");
 	return padded_size - last_unit;
 }
 
 static bool encrypt_packet(struct sk_buff *skb, struct noise_keypair *keypair)
 {
-	unsigned int padding_len, plaintext_len, trailer_len;
-	struct scatterlist sg[MAX_SKB_FRAGS + 8];
-	struct message_data *header;
-	struct sk_buff *trailer;
-	int num_frags;
-
-	/* Force hash calculation before encryption so that flow analysis is
-	 * consistent over the inner packet.
-	 */
-	skb_get_hash(skb);
+    unsigned int padding_len, plaintext_len, trailer_len;
+    struct scatterlist sg[MAX_SKB_FRAGS + 8];
+    struct message_data *header;
+    struct sk_buff *trailer;
+    int num_frags;
+
+    wg_dbg("Entering encrypt_packet with skb=%px, keypair=%px\n", skb, keypair);
+    wg_dbg("skb->len = %u, skb->data_len = %u, skb->network_header = %px\n", skb->len, skb->data_len, skb_network_header(skb));
+    wg_dbg("keypair->remote_index = %u\n", keypair->remote_index);
+    wg_dbg("skb->data (before encryption): %*ph\n", skb->len, skb->data);
+#ifdef WG_TCP_VERBOSE
+    decode_and_print_packet(skb, "[encrypt]");
+#endif
+
+    /* Force hash calculation before encryption */
+    skb_get_hash(skb);
+    wg_dbg("Hash calculated for skb.\n");
+
+    /* Calculate lengths */
+    padding_len = calculate_skb_padding(skb);
+    trailer_len = padding_len + noise_encrypted_len(0);
+    plaintext_len = skb->len + padding_len;
+    wg_dbg("Calculated lengths: padding_len=%u, trailer_len=%u, plaintext_len=%u\n", padding_len, trailer_len, plaintext_len);
+
+    /* Expand head section */
+    if (unlikely(skb_cow_head(skb, DATA_PACKET_HEAD_ROOM) < 0)) {
+        wg_dbg("Failed skb_cow_head, skb->len=%u, skb->head=%px\n", skb->len, skb->head);
+        wg_dbg("Exiting encrypt_packet with false\n");
+        return false;
+    }
+    wg_dbg("Expanded head section, skb->len=%u, skb->head=%px\n", skb->len, skb->head);
+
+    /* Finalize checksum calculation */
+    if (unlikely(skb->ip_summed == CHECKSUM_PARTIAL && skb_checksum_help(skb))) {
+        wg_dbg("Failed skb_checksum_help, skb->len=%u\n", skb->len);
+        wg_dbg("Exiting encrypt_packet with false\n");
+        return false;
+    }
+    wg_dbg("Checksum finalized, skb->len=%u\n", skb->len);
+
+    /* Expand data only after checksum completion; skb_checksum_help() may
+     * alter the packet layout and invalidate an earlier trailer pointer.
+     */
+    num_frags = skb_cow_data(skb, trailer_len, &trailer);
+    if (unlikely(num_frags < 0 || num_frags > ARRAY_SIZE(sg))) {
+        wg_dbg("Failed skb_cow_data: num_frags=%d, skb->len=%u\n", num_frags, skb->len);
+        wg_dbg("Exiting encrypt_packet with false\n");
+        return false;
+    }
+
+    memset(skb_tail_pointer(trailer), 0, padding_len);
+    wg_dbg("Padding set to zeros: padding_len=%u, skb->len=%u\n", padding_len, skb->len);
+
+    /* Add padding and header */
+    skb_set_inner_network_header(skb, 0);
+    header = (struct message_data *)skb_push(skb, sizeof(*header));
+    header->header.type = cpu_to_le32(MESSAGE_DATA);
+    header->key_idx = keypair->remote_index;
+    header->counter = cpu_to_le64(PACKET_CB(skb)->nonce);
+    wg_dbg("Nonce for encryption: %llu\n", PACKET_CB(skb)->nonce);
+#define NOISE_KEY_LEN 32
+    wg_dbg("Encryption key: %*ph\n", NOISE_KEY_LEN, keypair->sending.key);
+    pskb_put(skb, trailer, trailer_len);
+    wg_dbg("Header and padding added: type=%u, key_idx=%u, counter=%llu\n",
+           MESSAGE_DATA, keypair->remote_index, PACKET_CB(skb)->nonce);
+    wg_dbg("Network header set: skb_network_header=%px, skb->len=%u\n", skb_network_header(skb), skb->len);
+
+    /* Encrypt the scattergather segments */
+    sg_init_table(sg, num_frags);
+    if (skb_to_sgvec(skb, sg, sizeof(struct message_data), noise_encrypted_len(plaintext_len)) <= 0) {
+        wg_dbg("Failed skb_to_sgvec, skb->len=%u\n", skb->len);
+        wg_dbg("Exiting encrypt_packet with false\n");
+        return false;
+    }
+
+    wg_dbg("Scattergather segments prepared, starting encryption\n");
+
+    bool success = chacha20poly1305_encrypt_sg_inplace(sg, plaintext_len, NULL, 0,
+                                                       PACKET_CB(skb)->nonce,
+                                                       keypair->sending.key);
+    wg_dbg("skb->data (after encryption): %*ph\n", skb->len, skb->data);
+    wg_dbg("Exiting encrypt_packet with %s, skb->len=%u\n", success ? "true" : "false", skb->len);
+    return success;
+}
 
-	/* Calculate lengths. */
-	padding_len = calculate_skb_padding(skb);
-	trailer_len = padding_len + noise_encrypted_len(0);
-	plaintext_len = skb->len + padding_len;
+/* Helper function to extract IPv4 fragmentation info */
+static inline bool wg_ipv4_get_fraginfo(const struct sk_buff *skb,
+					__be16 *id, __be16 *frag_off)
+{
+	const struct iphdr *iph;
 
-	/* Expand data section to have room for padding and auth tag. */
-	num_frags = skb_cow_data(skb, trailer_len, &trailer);
-	if (unlikely(num_frags < 0 || num_frags > ARRAY_SIZE(sg)))
+	if (skb->protocol != htons(ETH_P_IP))
 		return false;
 
-	/* Set the padding to zeros, and make sure it and the auth tag are part
-	 * of the skb.
-	 */
-	memset(skb_tail_pointer(trailer), 0, padding_len);
-
-	/* Expand head section to have room for our header and the network
-	 * stack's headers.
-	 */
-	if (unlikely(skb_cow_head(skb, DATA_PACKET_HEAD_ROOM) < 0))
+	if (!pskb_may_pull((struct sk_buff *)skb, sizeof(struct iphdr)))
 		return false;
 
-	/* Finalize checksum calculation for the inner packet, if required. */
-	if (unlikely(skb->ip_summed == CHECKSUM_PARTIAL &&
-		     skb_checksum_help(skb)))
-		return false;
+	iph = ip_hdr(skb);
+	if (!(iph->frag_off & htons(IP_MF | IP_OFFSET)))
+		return false; /* not fragmented */
 
-	/* Only after checksumming can we safely add on the padding at the end
-	 * and the header.
-	 */
-	skb_set_inner_network_header(skb, 0);
-	header = (struct message_data *)skb_push(skb, sizeof(*header));
-	header->header.type = cpu_to_le32(MESSAGE_DATA);
-	header->key_idx = keypair->remote_index;
-	header->counter = cpu_to_le64(PACKET_CB(skb)->nonce);
-	pskb_put(skb, trailer, trailer_len);
-
-	/* Now we can encrypt the scattergather segments */
-	sg_init_table(sg, num_frags);
-	if (skb_to_sgvec(skb, sg, sizeof(struct message_data),
-			 noise_encrypted_len(plaintext_len)) <= 0)
-		return false;
-	return chacha20poly1305_encrypt_sg_inplace(sg, plaintext_len, NULL, 0,
-						   PACKET_CB(skb)->nonce,
-						   keypair->sending.key);
+	*id = iph->id;
+	*frag_off = iph->frag_off;
+	return true;
 }
 
 void wg_packet_send_keepalive(struct wg_peer *peer)
 {
+	wg_dbg("Entering wg_packet_send_keepalive with peer=%px\n", peer);
 	struct sk_buff *skb;
 
-	if (skb_queue_empty(&peer->staged_packet_queue)) {
+	if (skb_queue_empty_lockless(&peer->staged_packet_queue)) {
 		skb = alloc_skb(DATA_PACKET_HEAD_ROOM + MESSAGE_MINIMUM_LENGTH,
 				GFP_ATOMIC);
-		if (unlikely(!skb))
+		if (unlikely(!skb)) {
+			wg_dbg("Exiting wg_packet_send_keepalive\n");
 			return;
+		}
 		skb_reserve(skb, DATA_PACKET_HEAD_ROOM);
 		skb->dev = peer->device->dev;
 		PACKET_CB(skb)->mtu = skb->dev->mtu;
@@ -237,10 +374,12 @@ void wg_packet_send_keepalive(struct wg_peer *peer)
 	}
 
 	wg_packet_send_staged_packets(peer);
+	wg_dbg("Exiting wg_packet_send_keepalive\n");
 }
 
 static void wg_packet_create_data_done(struct wg_peer *peer, struct sk_buff *first)
 {
+	wg_dbg("Entering wg_packet_create_data_done with peer=%px, first=%px\n", peer, first);
 	struct sk_buff *skb, *next;
 	bool is_keepalive, data_sent = false;
 
@@ -257,10 +396,12 @@ static void wg_packet_create_data_done(struct wg_peer *peer, struct sk_buff *fir
 		wg_timers_data_sent(peer);
 
 	keep_key_fresh(peer);
+	wg_dbg("Exiting wg_packet_create_data_done\n");
 }
 
 void wg_packet_tx_worker(struct work_struct *work)
 {
+	wg_dbg("Entering wg_packet_tx_worker with work=%px\n", work);
 	struct wg_peer *peer = container_of(work, struct wg_peer, transmit_packet_work);
 	struct noise_keypair *keypair;
 	enum packet_state state;
@@ -282,10 +423,12 @@ void wg_packet_tx_worker(struct work_struct *work)
 		if (need_resched())
 			cond_resched();
 	}
+	wg_dbg("Exiting wg_packet_tx_worker\n");
 }
 
 void wg_packet_encrypt_worker(struct work_struct *work)
 {
+	wg_dbg("Entering wg_packet_encrypt_worker with work=%px\n", work);
 	struct crypt_queue *queue = container_of(work, struct multicore_worker,
 						 work)->ptr;
 	struct sk_buff *first, *skb, *next;
@@ -306,10 +449,12 @@ void wg_packet_encrypt_worker(struct work_struct *work)
 		if (need_resched())
 			cond_resched();
 	}
+	wg_dbg("Exiting wg_packet_encrypt_worker\n");
 }
 
 static void wg_packet_create_data(struct wg_peer *peer, struct sk_buff *first)
 {
+	wg_dbg("Entering wg_packet_create_data with peer=%px, first=%px\n", peer, first);
 	struct wg_device *wg = peer->device;
 	int ret = -EINVAL;
 
@@ -317,41 +462,50 @@ static void wg_packet_create_data(struct wg_peer *peer, struct sk_buff *first)
 	if (unlikely(READ_ONCE(peer->is_dead)))
 		goto err;
 
+	wg_dbg("wg_packet_create_data sending: %*ph\n", first->len, first->data);
+
 	ret = wg_queue_enqueue_per_device_and_peer(&wg->encrypt_queue, &peer->tx_queue, first,
 						   wg->packet_crypt_wq);
 	if (unlikely(ret == -EPIPE))
 		wg_queue_enqueue_per_peer_tx(first, PACKET_STATE_DEAD);
+
 err:
 	rcu_read_unlock_bh();
-	if (likely(!ret || ret == -EPIPE))
+	if (likely(!ret || ret == -EPIPE)) {
+		wg_dbg("Exiting wg_packet_create_data\n");
 		return;
+	}
 	wg_noise_keypair_put(PACKET_CB(first)->keypair, false);
 	wg_peer_put(peer);
 	kfree_skb_list(first);
+	wg_dbg("Exiting wg_packet_create_data with error.\n");
 }
 
 void wg_packet_purge_staged_packets(struct wg_peer *peer)
 {
+	wg_dbg("Entering wg_packet_purge_staged_packets with peer=%px\n", peer);
 	spin_lock_bh(&peer->staged_packet_queue.lock);
 	DEV_STATS_ADD(peer->device->dev, tx_dropped,
 		      peer->staged_packet_queue.qlen);
 	__skb_queue_purge(&peer->staged_packet_queue);
 	spin_unlock_bh(&peer->staged_packet_queue.lock);
+	wg_dbg("Exiting wg_packet_purge_staged_packets\n");
 }
 
 void wg_packet_send_staged_packets(struct wg_peer *peer)
 {
+	wg_dbg("Entering wg_packet_send_staged_packets with peer=%px\n", peer);
 	struct noise_keypair *keypair;
 	struct sk_buff_head packets;
 	struct sk_buff *skb;
-
-	/* Steal the current queue into our local one. */
 	__skb_queue_head_init(&packets);
 	spin_lock_bh(&peer->staged_packet_queue.lock);
 	skb_queue_splice_init(&peer->staged_packet_queue, &packets);
 	spin_unlock_bh(&peer->staged_packet_queue.lock);
-	if (unlikely(skb_queue_empty(&packets)))
+	if (unlikely(skb_queue_empty(&packets))) {
+		wg_dbg("Exiting wg_packet_send_staged_packets\n");
 		return;
+	}
 
 	/* First we make sure we have a valid reference to a valid key. */
 	rcu_read_lock_bh();
@@ -380,12 +534,38 @@ void wg_packet_send_staged_packets(struct wg_peer *peer)
 				atomic64_inc_return(&keypair->sending_counter) - 1;
 		if (unlikely(PACKET_CB(skb)->nonce >= REJECT_AFTER_MESSAGES))
 			goto out_invalid;
+
+		/* XXX - Jeff:
+		 *  This codepath is only executed for for keepalives,
+		 *  when an interface comes up, or when set_peer is called.
+		 *  This is likely unnecessary and we'll revisit it
+		 *  for removal
+		 */
+		/* Extract fragmentation info if this is IPv4 and fragmented */
+		if (peer->device->transport == WG_TRANSPORT_TCP &&
+		    skb->protocol == htons(ETH_P_IP)) {
+			__be16 id = 0, frag_off = 0;
+			if (wg_ipv4_get_fraginfo(skb, &id, &frag_off)) {
+				PACKET_CB(skb)->frag_id = id;
+				PACKET_CB(skb)->frag_off = frag_off;
+				wg_dbg("Fragmentation detected: id=%u, frag_off=0x%x\n",
+				       ntohs(id), ntohs(frag_off));
+			} else {
+				PACKET_CB(skb)->frag_id = 0;
+				PACKET_CB(skb)->frag_off = 0;
+			}
+		} else {
+			/* Non-IPv4 packets don't have fragmentation info */
+			PACKET_CB(skb)->frag_id = 0;
+			PACKET_CB(skb)->frag_off = 0;
+		}
 	}
 
 	packets.prev->next = NULL;
 	wg_peer_get(keypair->entry.peer);
 	PACKET_CB(packets.next)->keypair = keypair;
 	wg_packet_create_data(peer, packets.next);
+	wg_dbg("Exiting wg_packet_send_staged_packets\n");
 	return;
 
 out_invalid:
@@ -411,4 +591,5 @@ out_nokey:
 	 * means we should initiate a new handshake.
 	 */
 	wg_packet_send_queued_handshake_initiation(peer, false);
+	wg_dbg("Exiting wg_packet_send_staged_packets\n");
 }
